package com.massa.mrules.droolsfight.tests;

import org.junit.Assert;

import com.massa.log.Log;
import com.massa.mrules.droolsfight.beans.MeasureBean;

public class AbstractTest {

	protected void checkResult(final Log log, final MeasureBean data, final int idx) {
		log.debug("idx:  " + (idx));
		log.debug("results:  " + data.getErrors());
		log.debug("expected: " + data.getExpectedErrors());
		log.debug("nbBlocking: expected : " + data.getExpectedNbBlocking() + " - obtained " + data.getNbBlocking());
		log.debug("airQuality: expected : " + data.getExpectedAirQuality() + " - obtained " + data.getAirQuality());
		log.debug("");

		final int len = data.getErrors() == null ? 0 : data.getErrors().size();
		final int explen = data.getExpectedErrors() == null ? 0 : data.getExpectedErrors().size();
		if (len != explen) {
			Assert.fail("Obtained errors do not match with expected (idx: " + idx + ") :\n"
					+ " Expected: " + data.getExpectedErrors()
					+ " Obtained:  " + data.getErrors());
		}
		if (len > 0 && (
				!data.getErrors().containsAll(data.getExpectedErrors()) || !data.getExpectedErrors().containsAll(data.getErrors())
				)) {
			Assert.fail("Obtained errors do not match with expected (idx: " + idx + ") :\n"
					+ " Expected: " + data.getExpectedErrors()
					+ " Obtained:  " + data.getErrors());

		}

		Assert.assertEquals("The error count do not match expected value (idx: " + idx + ") :\n",
				data.getExpectedNbBlocking(), data.getNbBlocking());
		Assert.assertEquals("The air quality index do not match expected value (idx: " + idx + ") :\n",
				data.getExpectedAirQuality(), data.getAirQuality());
	}
}
